﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Configuration

Public Class AcessoDados

    Dim Da As New OleDbDataAdapter
    Dim Dt As DataTable
    Dim Cmd As New OleDbCommand
    Dim cn As New OleDb.OleDbConnection

    Public Function getConexaoDB() As OleDbConnection
        Try
            'cn.ConnectionString = "Provider=Microsoft.Jet.OleDb.4.0; Data Source=c:\dados\Escola.mdb"
            cn.ConnectionString = ConfigurationManager.ConnectionStrings("ConexaoEscolaMDB").ConnectionString
            cn.Open()
            Return cn
        Catch ex As Exception
            Throw ex
        End Try
    End Function
    Public Sub closeConexaoDB(ByVal cn As OleDbConnection)
        Try
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
    Public Sub incluirDados(ByVal nome As String, ByVal arrImage() As Byte, ByVal strImage As String)
        Try
            cn = getConexaoDB()
            Cmd.Connection = cn
            Cmd.CommandText = "INSERT INTO Alunos(nome, imagem) " & _
                              "VALUES( '" & nome & "'," & strImage & ")"

            If strImage = "?" Then
                Cmd.Parameters.Add(strImage, OleDb.OleDbType.Binary).Value = arrImage
            End If

            Cmd.ExecuteNonQuery()
        Catch ex As Exception
            Throw ex
        Finally
            closeConexaoDB(cn)
        End Try
    End Sub
    Public Function procurarDados(ByVal codigo As Integer) As Aluno

        Dim aluno As New Aluno

        Try
            cn = getConexaoDB()
            Dim da As New OleDb.OleDbDataAdapter("SELECT * FROM Alunos " & _
                                                " WHERE codigo=" & codigo, cn)
            Dim dt As New DataTable
            Dim arrImage() As Byte = Nothing
            Dim myMS As New IO.MemoryStream

            da.Fill(dt)

            If dt.Rows.Count > 0 Then
                aluno.Codigo = dt.Rows(0).Item("codigo")
                aluno.Nome = dt.Rows(0).Item("nome") & ""
                If Not IsDBNull(dt.Rows(0).Item("imagem")) Then
                    arrImage = dt.Rows(0).Item("imagem")
                    For Each ar As Byte In arrImage
                        myMS.WriteByte(ar)
                    Next
                    aluno.Imagem = System.Drawing.Image.FromStream(myMS)
                Else
                    aluno.Imagem = Nothing
                End If
            Else
                aluno = Nothing
            End If
        Catch ex As Exception
            Throw ex
        Finally
            closeConexaoDB(cn)
        End Try
        Return Aluno

    End Function
    Public Function carregaDados() As DataTable
        Dt = New DataTable
        cn = getConexaoDB()
        Try
            With Cmd
                .CommandType = CommandType.Text
                .CommandText = "SELECT * from Alunos"
                .Connection = cn
            End With
            With Da
                .SelectCommand = Cmd
                .Fill(Dt)
            End With
        Catch ex As Exception
            Dt = Nothing
        Finally
            closeConexaoDB(cn)
        End Try
        Return Dt
    End Function
    Public Sub deletarRegistro(ByVal codigo As Integer)

        Try
            cn = getConexaoDB()
            Dim myCmd As New OleDb.OleDbCommand
            myCmd.Connection = cn

            myCmd.CommandText = "DELETE FROM Alunos WHERE codigo = " & codigo

            myCmd.ExecuteNonQuery()

        Catch ex As Exception
            Throw ex
        Finally
            closeConexaoDB(cn)
        End Try
    End Sub
    Public Sub atualizarDados(ByVal nome As String, strImagem As String, codigo As Integer, arrImagem() As Byte)
        Try
            cn = getConexaoDB()
            Dim myCmd As New OleDb.OleDbCommand
            myCmd.Connection = cn
            myCmd.CommandText = "Update Alunos SET nome = '" & nome & "'," & "imagem = " & strImagem & " WHERE codigo =" & codigo

            If strImagem = "?" Then
                myCmd.Parameters.Add(strImagem, OleDb.OleDbType.Binary).Value = arrImagem
            End If

            myCmd.ExecuteNonQuery()
        Catch ex As Exception
            Throw ex
        Finally
            closeConexaoDB(cn)
        End Try
    End Sub
End Class
